## ns3 3.46

=== CMakeLists.txt ===
# ##############################################################################
# Required CMake version            #
# ##############################################################################
cmake_minimum_required(VERSION 3.20..3.20)

# ##############################################################################
# Project name                        #
# ##############################################################################
project(NS3 CXX)

file(STRINGS VERSION NS3_VER)

# minimum compiler versions
set(AppleClang_MinVersion 15.0.0)
set(Clang_MinVersion 17.0.0)
set(GNU_MinVersion 11.0.0)

# common options
option(NS3_ASSERT "Enable assert on failure" OFF)
option(NS3_DES_METRICS "Enable DES Metrics event collection" OFF)
option(NS3_EXAMPLES "Enable examples to be built" OFF)
option(NS3_LOG "Enable logging to be built" OFF)
option(NS3_TESTS "Enable tests to be built" OFF)

# fd-net-device options
option(NS3_EMU "Build with emulation support" ON)
option(NS3_TAP "Build with Tap support" ON)
option(NS3_DPDK "Enable fd-net-device DPDK features" OFF)

# maintenance and documentation
option(NS3_CLANG_FORMAT "Enforce cody style with clang-format" OFF)
option(NS3_CLANG_TIDY "Use clang-tidy static analysis" OFF)
option(NS3_CLANG_TIMETRACE
       "Collect compilation statistics to analyze the build process" OFF
)
option(NS3_COLORED_OUTPUT "Colorize CMake messages" OFF)
option(NS3_COVERAGE "Enable code coverage measurements and report generation"
       OFF
)
option(NS3_COVERAGE_ZERO_COUNTERS
       "Zero lcov counters before running. Requires NS3_COVERAGE=ON" OFF
)
option(NS3_INCLUDE_WHAT_YOU_USE
       "Use IWYU to determine unnecessary headers included" OFF
)
option(NS3_LINK_WHAT_YOU_USE
       "Use LWYU to determine unnecessary linked libraries" OFF
)
option(NS3_SANITIZE "Build with address, leak and undefined sanitizers" OFF)
option(NS3_SANITIZE_MEMORY "Build with memory sanitizer" OFF)

# 3rd-party libraries/programs
option(NS3_NETANIM "Build netanim" OFF)

# other options
option(NS3_ENABLE_BUILD_VERSION "Embed version info into libraries" OFF)
option(NS3_CCACHE "Use Ccache to speed up recompilation" ON)
option(NS3_CPM "Enable the CPM C++ library manager support" OFF)
option(NS3_FAST_LINKERS "Use Mold or LLD to speed up linking if available" ON)
option(NS3_FETCH_OPTIONAL_COMPONENTS
       "Fetch Brite, Click and Openflow dependencies" OFF
)
option(
  NS3_FORCE_LOCAL_DEPENDENCIES
  "Only search applications, headers, libraries on explicitly set directories"
  OFF
)
option(NS3_GSL "Build with GSL support" ON)
option(NS3_GTK3 "Build with GTK3 support" ON)
option(NS3_LINK_TIME_OPTIMIZATION "Build with link-time optimization" OFF)
option(NS3_MONOLIB
       "Build a single shared ns-3 library and link it against executables" OFF
)
option(NS3_MPI "Build with MPI support" OFF)
option(NS3_NATIVE_OPTIMIZATIONS "Build with -march=native -mtune=native" OFF)
option(
  NS3_NINJA_TRACING
  "Use ninjatracing to convert Ninja's build log to the about://tracing format"
  OFF
)
set(NS3_OUTPUT_DIRECTORY "" CACHE STRING "Directory to store built artifacts")
option(NS3_PRECOMPILE_HEADERS
       "Precompile module headers to speed up compilation" ON
)
option(NS3_PYTHON_BINDINGS "Build ns-3 python bindings" OFF)
option(NS3_SQLITE "Build with SQLite support" ON)
option(NS3_EIGEN "Build with Eigen support" ON)
option(NS3_STATIC "Build a static ns-3 library and link it against executables"
       OFF
)
option(NS3_VCPKG "Enable the Vcpkg C++ library manager support" OFF)
option(NS3_VERBOSE "Print additional build system messages" OFF)
option(NS3_VISUALIZER "Build visualizer module" ON)
option(NS3_WARNINGS "Enable compiler warnings" ON)
option(NS3_WARNINGS_AS_ERRORS
       "Treat warnings as errors. Requires NS3_WARNINGS=ON" ON
)

# Options that either select which modules will get built or disable modules
set(NS3_ENABLED_MODULES ""
    CACHE STRING "List of modules to enable (e.g. core;network;internet)"
)
set(NS3_DISABLED_MODULES "" CACHE STRING
                                  "List of modules to disable (e.g. lte;wifi)"
)

# Filter in the modules from which examples and tests will be built
set(NS3_FILTER_MODULE_EXAMPLES_AND_TESTS
    ""
    CACHE
      STRING
      "List of modules that should have their examples and tests built (e.g. lte;wifi)"
)

# Include macros used below
include(build-support/macros-and-definitions.cmake)

# Scan module libraries
subdirlist(libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/src)

# Scan contribution libraries
subdirlist(contrib_libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/contrib)

# Scan for additional contribution libraries OUTSIDE the ns-3 source directory,
# in the ns-3-external-contrib directory
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../ns-3-external-contrib)
  subdirlist(
    external_contrib_libs_to_build
    ${CMAKE_CURRENT_SOURCE_DIR}/../ns-3-external-contrib
  )
  set(contrib_libs_to_build ${contrib_libs_to_build}
                            ${external_contrib_libs_to_build}
  )
endif()

# Before filtering, we need to load settings from .ns3rc
parse_ns3rc(
  ns3rc_enabled_modules ns3rc_disabled_modules ns3rc_examples_enabled
  ns3rc_tests_enabled
)

# After scanning modules, we can filter enabled and disabled ones
filter_enabled_and_disabled_modules(
  libs_to_build contrib_libs_to_build NS3_ENABLED_MODULES NS3_DISABLED_MODULES
  ns3rc_enabled_modules ns3rc_disabled_modules
)

if(${NS3_CCACHE})
  # Use ccache if available
  mark_as_advanced(CCACHE)
  find_program(CCACHE ccache)
  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
    message(STATUS "CCache is enabled.")
    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
    execute_process(
      COMMAND
        ${CCACHE} --set-config
        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
    )
    if(DEFINED MSVC)
      if(MSVC)
        file(COPY_FILE ${CCACHE} ${CMAKE_BINARY_DIR}/clang-cl.exe
             ONLY_IF_DIFFERENT
        )
        set(CMAKE_VS_GLOBALS
            "CLToolExe=clang-cl.exe" "CLToolPath=${CMAKE_BINARY_DIR}"
            "TrackFileAccess=false" "UseMultiToolTask=true"
            "DebugInformationFormat=OldStyle"
        )
      endif()
    endif()
  endif()
endif()

# ##############################################################################
# Process options                     #
# ##############################################################################
process_options()

# ##############################################################################
# Add subdirectories                  #
# ##############################################################################
# Build NS3 library core
add_subdirectory(src)

# Build NS library examples
add_subdirectory(examples)

# Build scratch/simulation scripts
add_subdirectory(scratch)

# Build test utils
add_subdirectory(utils)

write_lock()
write_configtable()

# Export package targets when installing
ns3_cmake_package()

=== examples/CMakeLists.txt ===
if(${ENABLE_EXAMPLES})
  subdirlist(examples_to_build ${CMAKE_CURRENT_SOURCE_DIR})

  # Process subdirectories
  foreach(examplefolder ${examples_to_build})
    if(NOT (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${examplefolder}/CMakeLists.txt))
      continue()
    endif()
    add_subdirectory(${examplefolder})

    set(ns3-example-folders
        "${examplefolder};${ns3-example-folders}"
        CACHE INTERNAL "list of example folders"
    )
  endforeach()
endif()

scan_python_examples(${CMAKE_CURRENT_SOURCE_DIR})

=== scratch/CMakeLists.txt ===
set(target_prefix scratch_)

function(create_scratch source_files)
  # Return early if no sources in the subdirectory
  list(LENGTH source_files number_sources)
  if(number_sources EQUAL 0)
    return()
  endif()

  # If the scratch has more than a source file, we need to find the source with
  # the main function
  set(scratch_src)
  foreach(source_file ${source_files})
    file(READ ${source_file} source_file_contents)
    string(REGEX MATCHALL "main[(| (]" main_position "${source_file_contents}")
    if(CMAKE_MATCH_0)
      list(APPEND scratch_src ${source_file})
    endif()
  endforeach()

  list(LENGTH scratch_src scratch_src_len)

  # If there is no main function, raise an error
  if(${scratch_src_len} EQUAL 0)
    message(FATAL_ERROR "The following scratch source files do not contain a main function: ${source_files}")
  endif()

  # If there are multiple main functions, raise an error
  if(${scratch_src_len} GREATER 1)
    message(FATAL_ERROR "The following scratch source files contain ${scratch_src_len} files with a main function: ${scratch_src}")
  endif()

  # If there is a single main function, continue normally

  # Get parent directory name
  get_filename_component(scratch_dirname ${scratch_src} DIRECTORY)
  string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "" scratch_dirname
                 "${scratch_dirname}"
  )
  string(REPLACE "/" "_" scratch_dirname "${scratch_dirname}")

  # Get source name
  get_filename_component(scratch_name ${scratch_src} NAME_WLE)

  set(target_prefix scratch_)
  if(scratch_dirname)
    # Join the names together if dirname is not the scratch folder
    set(target_prefix scratch${scratch_dirname}_)
  endif()

  # Get source absolute path and transform into relative path
  get_filename_component(scratch_src ${scratch_src} ABSOLUTE)
  get_filename_component(scratch_absolute_directory ${scratch_src} DIRECTORY)
  string(REPLACE "${PROJECT_SOURCE_DIR}" "${CMAKE_OUTPUT_DIRECTORY}"
                 scratch_directory ${scratch_absolute_directory}
  )
  build_exec(
          EXECNAME ${scratch_name}
          EXECNAME_PREFIX ${target_prefix}
          SOURCE_FILES "${source_files}"
          LIBRARIES_TO_LINK "${ns3-libs}" "${ns3-contrib-libs}"
          EXECUTABLE_DIRECTORY_PATH ${scratch_directory}/
  )
endfunction()

# Scan *.cc files in ns-3-dev/scratch and build a target for each
file(GLOB single_source_file_scratches CONFIGURE_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/[^.]*.cc)
foreach(scratch_src ${single_source_file_scratches})
  create_scratch(${scratch_src})
endforeach()

# Scan ns-3-dev/scratch subdirectories
file(
  GLOB scratch_subdirectories
  CONFIGURE_DEPENDS
  LIST_DIRECTORIES true
  ${CMAKE_CURRENT_SOURCE_DIR}/**
)
# Filter out files
foreach(entry ${scratch_subdirectories})
  if(NOT (IS_DIRECTORY ${entry}))
    list(REMOVE_ITEM scratch_subdirectories ${entry})
  endif()
endforeach()

# Build scratches per directory or following CMakeLists.txt instructions
foreach(subdir ${scratch_subdirectories})
  if(EXISTS ${subdir}/CMakeLists.txt)
    # If the subdirectory contains a CMakeLists.txt file
    # we let the CMake file manage the source files
    #
    # Use this if you want to link to external libraries
    # without creating a module
    add_subdirectory(${subdir})
  else()
    # Otherwise we pick all the files in the subdirectory
    # and create a scratch for them automatically
    file(GLOB scratch_sources CONFIGURE_DEPENDS ${subdir}/[^.]*.cc)
    create_scratch("${scratch_sources}")
  endif()
endforeach()

=== src/CMakeLists.txt ===
set(libs "${libs_to_build}")

# Process the visualizer module first if enabled
if(visualizer IN_LIST libs)
  if(${ENABLE_VISUALIZER})
    message(STATUS "Processing src/visualizer")
    add_subdirectory(visualizer)
  endif()
  list(REMOVE_ITEM libs visualizer)
endif()

# Process subdirectories
foreach(libname ${libs})
  if(EXISTS ${PROJECT_SOURCE_DIR}/src/${libname}/CMakeLists.txt)
    message(STATUS "Processing src/${libname}")
    add_subdirectory(${libname})
  else()
    message(${HIGHLIGHTED_STATUS}
            "Skipping src/${libname}: it does not contain a CMakeLists.txt file"
    )
  endif()
endforeach()

# Scan for disabled modules that define settings prefixed with NS3_ or ENABLE_
# so that we can initialize them as turned off (setting as temporary variables
# not to affect the cached variables that are set when normally processed)
subdirlist(modules ${CMAKE_CURRENT_SOURCE_DIR})
foreach(libname ${modules})
  if(NOT (${libname} IN_LIST libs))
    # Skip module directories without CMakeLists.txt files
    if(NOT (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${libname}/CMakeLists.txt))
      continue()
    endif()

    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/${libname}/CMakeLists.txt
         lib_cmakelists_contents
    )
    string(REGEX MATCHALL "(NS3_[a-zA-Z0-9_]*)|(ENABLE_[a-zA-Z0-9_]*)" flags
                 "${lib_cmakelists_contents}"
    )
    foreach(flag ${flags})
      # Skip reason flags
      if(${flag} MATCHES "REASON")
        continue()
      endif()
      # Skip flags already defined
      if(DEFINED ${flag})
        continue()
      endif()
      # Set flag to off
      set(${flag} OFF PARENT_SCOPE)
    endforeach()
  endif()
endforeach()

if(NOT ${XCODE})

  # Create object libraries from shared libraries to be reused by static and
  # monolib builds
  set(lib-ns3-static-objs)
  if(${NS3_STATIC} OR ${NS3_MONOLIB})
    foreach(module ${ns3-libs} ${ns3-contrib-libs})
      # Retrieve source files from shared library target
      get_target_property(target_sources ${module} SOURCES)

      # Prepend module path to source files
      set(FOLDER "src")
      if(${module} IN_LIST ns3-contrib-libs)
        set(FOLDER "contrib")
      endif()
      list(TRANSFORM target_sources
           PREPEND ${PROJECT_SOURCE_DIR}/${FOLDER}/${module}/
      )

      # Create object library from shared library
      add_library(${module}-obj OBJECT ${target_sources})

      # Reuse PCH
      if(${PRECOMPILE_HEADERS_ENABLED})
        target_precompile_headers(${module}-obj REUSE_FROM stdlib_pch)
      endif()

      # Retrieve properties from shared library target and apply to object
      foreach(property INCLUDE_DIRECTORIES LINK_DIRECTORIES
                       INTERFACE_COMPILE_DEFINITIONS
      )
        get_target_property(target_definitions ${module} ${property})
        if("${target_definitions}" MATCHES "target_definitions-NOTFOUND")
          continue()
        endif()
        if(${property} STREQUAL "INTERFACE_COMPILE_DEFINITIONS")
          set(property COMPILE_DEFINITIONS)
        endif()

        set_target_properties(
          ${module}-obj PROPERTIES ${property} "${target_definitions}"
        )
      endforeach()

      # Append to the list of object files
      list(APPEND lib-ns3-static-objs $<TARGET_OBJECTS:${module}-obj>)
    endforeach()
  endif()

  # Prevents link errors due to symbol collisions if the same library is linked
  # multiple times
  list(REMOVE_DUPLICATES ns3-external-libs)

  # Build the lib-ns3-static (ns3.x-static-buildtype.a/.lib) with all
  # sublibraries
  if(${NS3_STATIC})
    add_library(
      ${lib-ns3-static} STATIC ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                               "${lib-ns3-static-objs}"
    )

    # Replace shared library suffix and check if static version exists before
    # linking
    set(ns3-external-static-libs)
    foreach(sharedlib ${ns3-external-libs})
      if(NOT (${sharedlib} MATCHES ".so"))
        list(APPEND ns3-external-static-libs ${sharedlib})
        continue()
      endif()

      string(REPLACE ".so" ".a" output ${sharedlib})
      if(EXISTS ${output})
        list(APPEND ns3-external-static-libs ${output})
      else()
        message(
          FATAL_ERROR "Static library version of ${sharedlib} was not found"
        )
      endif()
    endforeach()

    # Required by some static libraries, such as sqlite, for some odd reason
    if(LINUX)
      list(APPEND ns3-external-static-libs -ldl)
    endif()

    target_link_libraries(
      ${lib-ns3-static} ${STATIC_LINK_FLAGS} ${LIB_AS_NEEDED_PRE_STATIC}
      ${ns3-external-static-libs} ${LIB_AS_NEEDED_POST_STATIC}
    )
    if(${NS3_CLANG_TIMETRACE})
      add_dependencies(timeTraceReport ${lib-ns3-static})
    endif()
  endif() # NS3_STATIC

  # Build the lib-ns3 (ns3.x-monolib-buildtype.dll/.dylib/.so) with all
  # sublibraries
  if(${NS3_MONOLIB})
    add_library(
      ${lib-ns3-monolib} SHARED ${PROJECT_SOURCE_DIR}/build-support/empty.cc
                                "${lib-ns3-static-objs}"
    )
    set_target_properties(
      ${lib-ns3-monolib}
      PROPERTIES INTERPROCEDURAL_OPTIMIZATION TRUE
                 RUNTIME_OUTPUT_DIRECTORY
                 ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} # set output directory for
                                                   # DLLs
    )
    target_link_libraries(
      ${lib-ns3-monolib} ${LIB_AS_NEEDED_PRE} ${ns3-external-libs}
      ${LIB_AS_NEEDED_POST}
    )
    if(${NS3_CLANG_TIMETRACE})
      add_dependencies(timeTraceReport ${lib-ns3-monolib})
    endif()
  endif() # NS3_MONOLIB

endif() # NOT XCODE

if(${NS3_FETCH_OPTIONAL_COMPONENTS})
  add_dependency_to_optional_modules_dependencies()
endif()

=== doc/contributing/Makefile ===
# Makefile for Sphinx documentation
#
include $(CURDIR)/../sphinx/defines.mk

# Internal variables.
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

# Additional variables for figures, not sphinx default:
FIGURES = source/figures
IMAGES_EPS = \

IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}

IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

.NOTPARALLEL:

%.eps : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t eps $< -e $@ >/dev/null

%.png : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t png $< -e $@ >/dev/null

%.png : %.eps
	@echo convert $(notdir $<)
	@$(CONVERT) $< $@ >/dev/null

%.pdf : %.eps
	@echo epstopdf $(notdir $<)
	@$(EPSTOPDF) $< -o=$@ >/dev/null
	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)

frag: pickle
	@if test ! -d $(BUILDDIR)/frag; then mkdir $(BUILDDIR)/frag; fi
	pushd $(BUILDDIR)/frag && ../../pickle-to-xml.py ../pickle/index.fpickle  > navigation.xml && popd
	cp -r $(BUILDDIR)/pickle/_images $(BUILDDIR)/frag

html: $(IMAGES)
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: $(IMAGES)
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: $(IMAGES)
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: $(IMAGES)
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: $(IMAGES)
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: $(IMAGES)
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: $(IMAGES)
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ns-3.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ns-3.qhc"

devhelp: $(IMAGES)
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/ns-3"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ns-3"
	@echo "# devhelp"

epub: $(IMAGES)
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: $(IMAGES)
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: $(IMAGES)
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes: $(IMAGES)
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: $(IMAGEs)
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: $(IMAGES)
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== doc/installation/Makefile ===
# Makefile for Sphinx documentation
#
include $(CURDIR)/../sphinx/defines.mk

# Internal variables.
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

# Additional variables for figures, not sphinx default:
FIGURES = source/figures
IMAGES_EPS = \

IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}

IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

.NOTPARALLEL:

%.eps : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t eps $< -e $@ >/dev/null

%.png : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t png $< -e $@ >/dev/null

%.png : %.eps
	@echo convert $(notdir $<)
	@$(CONVERT) $< $@ >/dev/null

%.pdf : %.eps
	@echo epstopdf $(notdir $<)
	@$(EPSTOPDF) $< -o=$@ >/dev/null
	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

frag: pickle
	@if test ! -d $(BUILDDIR)/frag; then mkdir $(BUILDDIR)/frag; fi
	pushd $(BUILDDIR)/frag && ../../pickle-to-xml.py ../pickle/index.fpickle  > navigation.xml && popd
	cp -r $(BUILDDIR)/pickle/_images $(BUILDDIR)/frag

html: $(IMAGES)
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: $(IMAGES)
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: $(IMAGES)
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: $(IMAGES)
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: $(IMAGES)
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: $(IMAGES)
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: $(IMAGES)
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ns-3.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ns-3.qhc"

devhelp: $(IMAGES)
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/ns-3"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ns-3"
	@echo "# devhelp"

epub: $(IMAGES)
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: $(IMAGES)
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: $(IMAGES)
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes: $(IMAGES)
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: $(IMAGEs)
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: $(IMAGES)
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== doc/manual/Makefile ===
include $(CURDIR)/../sphinx/defines.mk

SRC = ../../src
# Temporary source directory, for build
SOURCETEMP = source-temp
FIGURES = $(SOURCETEMP)/figures
#VPATH = $(FIGURES)

# list all manual .rst files that need to be copied to $SOURCETEMP
SOURCES = \
	source/conf.py \
	source/_static \
	source/index.rst \
	source/replace.txt \
	source/attributes.rst \
	source/callbacks.rst \
	source/develop.rst \
	source/documentation.rst \
	source/enable-modules.rst \
	source/enable-tests.rst \
	source/events.rst \
	source/features.rst \
	source/gnuplot.rst \
	source/hash-functions.rst \
	source/helpers.rst \
	source/how-to-write-tests.rst \
	source/logging-asserts.rst \
	source/new-models.rst \
	source/new-modules.rst \
	source/object-model.rst \
	source/object-names.rst \
	source/organization.rst \
	source/profiling.rst \
	source/python.rst \
	source/random-variables.rst \
	source/realtime.rst \
	source/simulator.rst \
	source/support.rst \
	source/test-background.rst \
	source/test-framework.rst \
	source/test-overview.rst \
	source/tests.rst \
	source/tracing.rst \
	source/troubleshoot.rst \
	source/utilities.rst \
	source/working-with-cilicon.rst \
	source/working-with-cmake.rst \
	source/working-with-docker.rst \
	source/working-with-git.rst \
	source/working-with-gitlab-ci-local.rst \
	${SRC}/stats/doc/data-collection.rst \
	${SRC}/stats/doc/data-collection-overview.rst \
	${SRC}/stats/doc/statistics.rst \
	${SRC}/stats/doc/data-collection-helpers.rst \
	${SRC}/stats/doc/probe.rst \
	${SRC}/stats/doc/collector.rst \
	${SRC}/stats/doc/aggregator.rst \
	${SRC}/stats/doc/adaptor.rst \
	${SRC}/stats/doc/scope-and-limitations.rst \

# list all manual figure files that need to be copied to
# $SOURCETEMP/figures.  For each figure to be included in all
# documentation formats (html, latex...) the following formats are supported:
#  1) a single .dia file (preferred option, because it can be edited)
#  2) a single .eps file
#  3) a single .png file
#  4) both a .pdf and .png file

SOURCEFIGS = \
    figures/software-organization.dia \
	figures/plot-2d.png \
	figures/plot-2d-with-error-bars.png \
	figures/plot-3d.png \
	figures/gtk-config-lena-dual-stripe-device-view.png \
	figures/gtk-config-lena-dual-stripe-eNB-tx-power.png \
	figures/heaptrack.png \
	figures/hotspot-cycles.png \
	figures/hotspot-setup.png \
	figures/hotspot-top-down.png \
	figures/perfetto-trace-cmake.png \
	figures/time-consuming-event-handling.png \
	figures/uprof-collect-callstack.png \
	figures/uprof-profile-application.png \
	figures/uprof-select-events.png \
	figures/uprof-start.png \
	figures/uprof-stats.png \
	figures/uprof-strace-lte.png \
	figures/vtune-configure.png \
	figures/vtune-landing.png \
	figures/vtune-perf-snapshot.png \
	figures/vtune-select-uarch-profiling.png \
	figures/vtune-uarch-core-stats.png \
	figures/vtune-uarch-profiling-summary.png \
	figures/vtune-uarch-wifi-stats.png \
	figures/perf.svg \
	figures/perf-lte-frequency-reuse.png \
	figures/perf-chunk-processor.png \
	figures/perf-detail.png \
	${SRC}/stats/doc/Stat-framework-arch.png \
	${SRC}/stats/doc/Wifi-default.png \
	${SRC}/stats/doc/dcf-overview.dia \
	${SRC}/stats/doc/dcf-overview-with-aggregation.dia \
	${SRC}/stats/doc/seventh-packet-byte-count.png \
	${SRC}/stats/doc/gnuplot-helper-example.png \
	${SRC}/stats/doc/gnuplot-aggregator.png \

# specify figures from which .png and .pdf figures need to be
# generated (all dia and eps figures)
IMAGES_EPS = \
	$(FIGURES)/software-organization.eps \
	$(FIGURES)/dcf-overview.eps \
	$(FIGURES)/dcf-overview-with-aggregation.eps \

# rescale pdf figures as necessary
$(FIGURES)/software-organization.pdf_width = 5in

IMAGES_PNG = $(IMAGES_EPS:.eps=.png)

IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}

IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)

RESCALE = ../../utils/rescale-pdf.sh

%.eps : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t eps $< -e $@ >/dev/null

%.png : %.dia
	@echo dia $(notdir $<)
	@$(DIA) -t png $< -e $@ >/dev/null

%.png : %.eps
	@echo convert $(notdir $<)
	@$(CONVERT) $< $@ >/dev/null

%.pdf : %.eps
	@echo epstopdf $(notdir $<)
	@$(EPSTOPDF) $< -o=$@ >/dev/null
	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi

# Internal variables.
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SOURCETEMP)

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

.NOTPARALLEL:

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

copy-sources:  $(SOURCES)
	@rm -rf $(SOURCETEMP)
	@mkdir -p $(SOURCETEMP)
	@mkdir -p $(FIGURES)
	@cp -r $(SOURCES) $(SOURCETEMP)
	@cp -r $(SOURCEFIGS) $(FIGURES)

clean:
	-rm -rf $(BUILDDIR)
	-rm -rf $(SOURCETEMP)

frag: pickle
	@if test ! -d $(BUILDDIR)/frag; then mkdir $(BUILDDIR)/frag; fi
	pushd $(BUILDDIR)/frag && ../../pickle-to-xml.py ../pickle/index.fpickle  > navigation.xml && popd
	cp -r $(BUILDDIR)/pickle/_images $(BUILDDIR)/frag

html: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ns-3.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ns-3.qhc"

devhelp: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/ns-3"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ns-3"
	@echo "# devhelp"

epub: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: copy-sources $(IMAGES)
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."


test: $(IMAGES)

=== doc/models/Makefile ===
include $(CURDIR)/../sphinx/defines.mk

SRC = ../../src
# Temporary source directory, for build
SOURCETEMP = source-temp
FIGURES = $(SOURCETEMP)/figures

# list all model library .rst files that need to be copied to $SOURCETEMP
SOURCES = \
	source/conf.py \
	source/_static \
	source/index.rst \
	source/replace.txt \
	source/organization.rst \
	source/internet-models.rst \
	source/network.rst \
	source/emulation-overview.rst \
	source/traffic-control.rst \
	$(SRC)/antenna/doc/antenna.rst \
	$(SRC)/aodv/doc/aodv.rst \
	$(SRC)/applications/doc/applications.rst \
	$(SRC)/bridge/doc/bridge.rst \
	$(SRC)/brite/doc/brite.rst \
	$(SRC)/buildings/doc/source/buildings.rst \
	$(SRC)/buildings/doc/source/buildings-design.rst \
	$(SRC)/buildings/doc/source/buildings-user.rst \
	$(SRC)/buildings/doc/source/buildings-testing.rst \
	$(SRC)/buildings/doc/source/buildings-references.rst \
	$(SRC)/click/doc/click.rst \
	$(SRC)/csma/doc/csma.rst \
	$(SRC)/dsdv/doc/dsdv.rst \
	$(SRC)/dsr/doc/dsr.rst \
	$(SRC)/mpi/doc/distributed.rst \
	$(SRC)/energy/doc/energy.rst \
	$(SRC)/fd-net-device/doc/fd-net-device.rst \
	$(SRC)/fd-net-device/doc/dpdk-net-device.rst \
	$(SRC)/fd-net-device/doc/netmap-net-device.rst \
	$(SRC)/tap-bridge/doc/tap.rst \
	$(SRC)/mesh/doc/source/mesh.rst \
	$(SRC)/mesh/doc/source/mesh-user.rst \
	$(SRC)/mesh/doc/source/mesh-design.rst \
	$(SRC)/mesh/doc/source/mesh-references.rst \
	$(SRC)/mesh/doc/source/mesh-testing.rst \
	$(SRC)/lte/doc/source/lte.rst \
	$(SRC)/lte/doc/source/lte-user.rst \
	$(SRC)/lte/doc/source/lte-design.rst \
	$(SRC)/lte/doc/source/lte-testing.rst \
	$(SRC)/lte/doc/source/lte-profiling.rst \
	$(SRC)/lte/doc/source/lte-references.rst \
	$(SRC)/propagation/doc/propagation.rst \
	$(SRC)/network/doc/network-overview.rst \
	$(SRC)/network/doc/packets.rst \
	$(SRC)/network/doc/error-model.rst \
	$(SRC)/network/doc/sockets-api.rst \
	$(SRC)/network/doc/simple.rst \
	$(SRC)/network/doc/queue.rst \
	$(SRC)/network/doc/queue-limits.rst \
	$(SRC)/nix-vector-routing/doc/nix-vector-routing.rst \
	$(SRC)/internet/doc/internet-stack.rst \
	$(SRC)/internet/doc/ipv4.rst \
	$(SRC)/internet/doc/ipv6.rst \
	$(SRC)/internet/doc/routing-overview.rst \
	$(SRC)/internet/doc/tcp.rst \
	$(SRC)/internet/doc/udp.rst \
	$(SRC)/internet-apps/doc/internet-apps.rst \
	$(SRC)/mobility/doc/mobility.rst \
	$(SRC)/olsr/doc/olsr.rst \
	$(SRC)/openflow/doc/openflow-switch.rst \
	$(SRC)/point-to-point/doc/point-to-point.rst \
	$(SRC)/wifi/doc/source/wifi.rst \
	$(SRC)/wifi/doc/source/wifi-design.rst \
	$(SRC)/wifi/doc/source/wifi-user.rst \
	$(SRC)/wifi/doc/source/wifi-testing.rst \
	$(SRC)/wifi/doc/source/wifi-changelog.rst \
	$(SRC)/wifi/doc/source/wifi-references.rst \
	$(SRC)/uan/doc/uan.rst \
	$(SRC)/topology-read/doc/topology.rst \
	$(SRC)/traffic-control/doc/traffic-control-layer.rst \
	$(SRC)/traffic-control/doc/queue-discs.rst \
	$(SRC)/traffic-control/doc/pfifo-fast.rst \
	$(SRC)/traffic-control/doc/fifo.rst \
	$(SRC)/traffic-control/doc/prio.rst \
	$(SRC)/traffic-control/doc/tbf.rst \
	$(SRC)/traffic-control/doc/red.rst \
	$(SRC)/traffic-control/doc/codel.rst \
	$(SRC)/traffic-control/doc/cobalt.rst \
	$(SRC)/traffic-control/doc/fq-codel.rst \
	$(SRC)/traffic-control/doc/fq-cobalt.rst \
	$(SRC)/traffic-control/doc/pie.rst \
	$(SRC)/traffic-control/doc/fq-pie.rst \
	$(SRC)/traffic-control/doc/mq.rst \
	$(SRC)/spectrum/doc/spectrum.rst \
	$(SRC)/netanim/doc/animation.rst \
	$(SRC)/flow-monitor/doc/flow-monitor.rst \
	$(SRC)/sixlowpan/doc/sixlowpan.rst \
	$(SRC)/lr-wpan/doc/lr-wpan.rst \
	$(SRC)/zigbee/doc/zigbee.rst \

# list all model library figure files that need to be copied to
# $SOURCETEMP/figures.  For each figure to be included in all
# documentation formats (html, latex...) the following formats are supported:
#  1) a single .dia file (preferred option, because it can be edited)
#  2) a single .eps file
#  3) a single .png file
#  4) both a .pdf and .png file
SOURCEFIGS = \
	figures/testbed.dia \
	figures/emulated-channel.dia \
	$(SRC)/antenna/doc/figures/antenna-coordinate-system.dia	\
	$(SRC)/antenna/doc/figures/circular-antenna-pattern.png	\
	$(SRC)/applications/doc/http-embedded-object-size.png \
	$(SRC)/applications/doc/http-main-object-size.png \
	$(SRC)/applications/doc/http-num-of-embedded-objects.png \
	$(SRC)/applications/doc/http-parsing-time.png \
	$(SRC)/applications/doc/http-reading-time.png \
	$(SRC)/dsr/doc/figures/dsrRreq.dia \
	$(SRC)/dsr/doc/figures/dsrRrep.dia \
	$(SRC)/network/doc/packet.dia \
	$(SRC)/network/doc/node.dia \
	$(SRC)/network/doc/buffer.dia \
	$(SRC)/network/doc/sockets-overview.dia \
	$(SRC)/internet/doc/internet-node-send.dia \
	$(SRC)/internet/doc/internet-node-recv.dia \
	$(SRC)/internet/doc/routing.dia \
	$(SRC)/internet/doc/routing-specialization.dia \
	$(SRC)/internet/doc/global-routing-limitation.dia \
	$(SRC)/internet/doc/figures/tcp-state-machine.png \
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-new-reno.png \
	$(SRC)/internet/doc/figures/ns3-new-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/ns3-bbr-vs-linux-bbr.png \
	$(SRC)/wifi/doc/source/figures/WifiArchitecture.dia \
	$(SRC)/wifi/doc/source/figures/PhyEntityHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/WifiPpduHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/FemHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/wifi-phy-rx-trace-helper.dia \
	$(SRC)/wifi/doc/source/figures/snir.dia \
	$(SRC)/wifi/doc/source/figures/ack-su-format.pdf \
	$(SRC)/wifi/doc/source/figures/ack-su-format.png \
	$(SRC)/wifi/doc/source/figures/assoc-manager.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-dl-txop.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-txop-ended-trace.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-ul-txop.eps \
	$(SRC)/wifi/doc/source/figures/mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/mu-bar.png \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.png \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.pdf \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.png \
	$(SRC)/wifi/doc/source/figures/clear-channel.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-n.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ac.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ax.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11a-p-1500-adhoc-r-54-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11g-p-1500-infrastructure-r-6-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/default-table-based-error-model-validation.eps \
	$(SRC)/wifi/doc/source/figures/error-models-comparison.eps \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.png \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.png \
	$(SRC)/lte/doc/source/figures/epc-ctrl-arch.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/epc-topology.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-x2-enhanced.dia \
	$(SRC)/lte/doc/source/figures/eutran-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/ff-example.dia \
	$(SRC)/lte/doc/source/figures/ff-mac-saps.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-enb-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-ue-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-handover-seq-diagram.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-control-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-interference-test-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-subframe-structure.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-interface.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-architecture.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-processes-scheme.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-consumer.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-motion.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1-hys.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-timeline.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-handover-target-scenario.dia \
	$(SRC)/lte/doc/source/figures/lena-dual-stripe.eps \
	$(SRC)/lte/doc/source/figures/lte-mcs-index.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase1.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase2.eps \
	$(SRC)/lte/doc/source/figures/runningTime10s.eps \
	$(SRC)/lte/doc/source/figures/epcRunningTime.eps \
	$(SRC)/lte/doc/source/figures/propagationModel.eps \
	$(SRC)/lte/doc/source/figures/simulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcSimulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcEutranRunningTime.eps \
	$(SRC)/lte/doc/source/figures/profiling-memory.eps \
	$(SRC)/lte/doc/source/figures/lte-rlc-implementation-model.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-entity-saps.dia \
	$(SRC)/lte/doc/source/figures/ca-rrc-reconf.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-enb-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-ue-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/lte-strongest-cell-handover-algorithm.eps \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.pdf \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.png \
	$(SRC)/lte/doc/source/figures/helpers.pdf \
	$(SRC)/lte/doc/source/figures/helpers.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-contention.png \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.pdf \
	$(SRC)/lte/doc/source/figures/mac-random-access-noncontention.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.pdf \
	$(SRC)/lte/doc/source/figures/rrc-connection-establishment.png \
	$(SRC)/lte/doc/source/figures/rrc-connection-reconfiguration.pdf \

=== examples/channel-models/CMakeLists.txt ===
build_example(
  NAME three-gpp-v2v-channel-example
  SOURCE_FILES three-gpp-v2v-channel-example.cc
  LIBRARIES_TO_LINK
    ${libcore}
    ${libmobility}
    ${libpropagation}
    ${libspectrum}
    ${libantenna}
    ${libbuildings}
)

=== examples/energy/CMakeLists.txt ===
build_example(
  NAME energy-model-example
  SOURCE_FILES energy-model-example.cc
  LIBRARIES_TO_LINK
    ${libcore}
    ${libmobility}
    ${libwifi}
    ${libenergy}
    ${libinternet}
    ${libconfig-store}
)

build_example(
  NAME energy-model-with-harvesting-example
  SOURCE_FILES energy-model-with-harvesting-example.cc
  LIBRARIES_TO_LINK
    ${libcore}
    ${libmobility}
    ${libwifi}
    ${libenergy}
    ${libinternet}
    ${libconfig-store}
)

=== examples/error-model/CMakeLists.txt ===
build_example(
  NAME simple-error-model
  SOURCE_FILES simple-error-model.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
)

=== examples/matrix-topology/CMakeLists.txt ===
build_example(
  NAME matrix-topology
  SOURCE_FILES matrix-topology.cc
  LIBRARIES_TO_LINK
    ${libnetwork}
    ${libnetanim}
    ${libmobility}
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
)

=== debian/changelog ===
ns3 (3.46-2) unstable; urgency=medium

  * Bump the soname to 3.46, stupid me (Closes: #1117871).

 -- Martin Quinson <mquinson@debian.org>  Sun, 12 Oct 2025 00:02:09 +0200

ns3 (3.46-1) unstable; urgency=medium

  * New upstream version.
  * Run wrap-and-sort -astkb
  * d/control: bump Standards-Version to 4.7.2 (no change needed).
  * d/p/no-rpath: new patch to not change the RPATH, as advised by lintian
  * d/rules: Activate hardening to please lintian

 -- Martin Quinson <mquinson@debian.org>  Fri, 10 Oct 2025 08:34:32 +0200

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 4.7.2
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders:
 YunQiang Su <syq@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-exec (>= 0.13),
 dh-python,
 bison,
 cmake,
 dpkg (>= 1.16.1),
 flex,
 gir1.2-gtk-3.0,
 ipython3,
# jdupes,
 libboost-filesystem-dev,
 libgraphviz-dev,
 libgsl-dev,
 libsqlite3-dev,
 libxml2-dev,
 pkgconf,
 python3-dev,
 python3-gi,
 python3-gi-cairo,
 python3-pygraphviz,
 quilt (>= 0.46-7~),
#Build-Depends-Indep:
# dia,
# doxygen,
# dvipng,
# ghostscript,
# imagemagick,
# latexmk,
# python3-sphinx,
# tex-gyre,
# texlive-font-utils,
# texlive-latex-extra,
# texlive-latex-base,
# texlive-latex-recommended,
Build-Conflicts:
 libmpich2-dev,
Vcs-Browser: https://salsa.debian.org/debian/ns3
Homepage: https://www.nsnam.org/
Vcs-Git: https://salsa.debian.org/debian/ns3.git

Package: ns3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: discrete-event network simulator for Internet systems
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains several utilities. The files for development
 are in libns3-3, libns3-dev and python3-ns3.

# Package: ns3-doc
# Architecture: all
# Build-Profiles: <!nodoc>
# Multi-Arch: foreign
# Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery, libjs-sphinxdoc
# Section: doc
# Description: documentation for ns-3
#  ns-3 is a discrete-event network simulator for Internet systems,
#  targeted primarily for research and educational use.
#  ns-3 is free software, licensed under the GNU GPLv2 license,
#  and is publicly available for research, development, and use.
#  ns-3 is intended as an eventual replacement for the popular
#  ns-2 simulator. The project acronym “nsnam” derives
#  historically from the concatenation of ns (network simulator)
#  and NAM (network animator).
#  .
#  This package contains manual, modules, tutorial and doxygen.

Package: libns3-dev
Architecture: any
Depends:
 g++,
 libns3.46 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 ns3 (= 3.25+dfsg2-2),
Section: libdevel
Description: Static and header files of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains static libraries, header files.

# Note to self: when updating this, you also need to update the SONAME in the relevant patch
Package: libns3.46
Provides:
 ${t64:Provides},
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: shared libraries of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains shared libraries.

#Package: python3-ns3
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
#  python3-pygraphviz
#Section: python
#Suggests: tcpdump
#Breaks: python-ns3
#Description: Python binding of ns3
# ns-3 is a discrete-event network simulator for Internet systems,
# targeted primarily for research and educational use.
# ns-3 is free software, licensed under the GNU GPLv2 license,
# and is publicly available for research, development, and use.
# ns-3 is intended as an eventual replacement for the popular
# ns-2 simulator. The project acronym “nsnam” derives
# historically from the concatenation of ns (network simulator)
# and NAM (network animator).
# .
# This package contains Python binding of ns3.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildopts.mk
include /usr/share/dpkg/pkg-info.mk

ifeq ($(DEB_HOST_GNU_CPU),mipsel)
  # Drop the debug symbols all together on mipsel to avoid OOM causing FTBFS
  export DEB_CFLAGS_MAINT_STRIP=-g
  export DEB_CXXFLAGS_MAINT_STRIP=-g
endif

# Define CFLAGS and friends to harden the build -- must come any addtion to these variables
DPKG_EXPORT_BUILDFLAGS = 1


ifeq ($(DEB_HOST_GNU_CPU),mipsel)
  # Further reduce the memory consumption on mipsel
  LDFLAGS += -Wl,--reduce-memory-overheads -Wl,--no-keep-memory
endif

TOPDIR=$(CURDIR)
PYBINDGENV_DIR=$(shell ls -d pybindgen-*)

# Build in parallel, unless there is less than 3GiB
MEMORY=$(shell awk '/MemTotal:/{print $$2}' /proc/meminfo)
BUILD_OPTION=$(shell if [ $(MEMORY) -lt 3090252 ]; then echo "-j1"; else echo "$(DEB_BUILD_OPTION_PARALLEL:%=-j%)"; fi)

# Reproducible Build wants us to use always the same date when building the documentation
SPHINXOPTS := -D today=\"$(SOURCE_DATE_EPOCH)\"
SPHINXOPTS += -D html_last_updated_fmt=\"$(SOURCE_DATE_EPOCH)\"

# Include version information
VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+dfsg.*//' | sed -e 's/\+ds.*//')
MAJOR_VERSION=$(word 1,$(subst ., ,$(VERSION)))
MINOR_VERSION=$(word 2,$(subst ., ,$(VERSION)))
PATCH_VERSION=$(word 3,$(subst ., ,$(VERSION).0)) # Add an extra .0 just in case there is no patch level

BUILD_PROFILE=release

%:
	dh $@ --with python3 --buildsystem=cmake

# Set up version cache to allow generating version module. The double 0 is due to a CMake peculiarity.

execute_before_dh_auto_configure:
	sed -e "s/@NS3_VERSION_CLOSEST_TAG@/NONEXISTENT_TAG__PACKAGE_BUILT_FROM_DEBIAN_SOURCE/" \
	    -e "s/@NS3_VERSION_COMMIT_HASH@//" \
	    -e "s/@NS3_VERSION_DIRTY_FLAG@/1/" \
	    -e "s/@NS3_VERSION_MAJOR@/$(MAJOR_VERSION)/" \
	    -e "s/@NS3_VERSION_MINOR@/$(MINOR_VERSION)/" \
	    -e "s/@NS3_VERSION_PATCH@/$(PATCH_VERSION)/" \
	    -e "s/@NS3_VERSION_RELEASE_CANDIDATE@//" \
	    -e "s/@NS3_VERSION_TAG@/NONEXISTENT_TAG__PACKAGE_BUILT_FROM_DEBIAN_SOURCE/" \
	    -e "s/@NS3_VERSION_TAG_DISTANCE@/00/" \
	    -e "s/@NS3_VERSION_BUILD_PROFILE@/$(BUILD_PROFILE)/" \
	    build-support/version.cache.in > src/core/model/version.cache

# Use the ns3 wrapper over cmake because I fail to get it work otherwise,
# but pass the parameters that cmake needs to build a proper Debian package (copied from the simgrid build logs)

override_dh_auto_configure:
	./ns3 configure --verbose \
		--build-profile=$(BUILD_PROFILE) --enable-python-bindings --enable-logs --enable-examples --enable-tests --disable-mpi --enable-build-version \
                --prefix=/usr -- \
		-DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON \
		-DCMAKE_INSTALL_RUNSTATEDIR=/run -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) -DCMAKE_INSTALL_PREFIX=/usr

override_dh_auto_build-arch:
	./ns3 build --verbose

# override_dh_auto_build-indep:
# ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
#	echo "XXXX run: SPHINXOPTS='$(SPHINXOPTS)' ./ns3 docs -v sphinx"
#	export SPHINXOPTS="$(SPHINXOPTS)"; ./ns3 docs -v sphinx
#	echo "XXXX done: ./ns3 docs sphinx"
# 	echo "XXXX run: SPHINXOPTS='$(SPHINXOPTS)' ./ns3 docs -v html"
# 	export SPHINXOPTS="$(SPHINXOPTS)"; ./ns3 docs -v html
# 	echo "XXXX done: ./ns3 docs -v html"
# 	rm -f doc/*/build/*/_static/jquery.js
# 	rm -f doc/*/build/*/_static/underscore.js
# else
# 	for d in manual models tutorial ; do mkdir -p doc/$$d/build/html ; touch doc/$$d/build/html/index.html ; done
# endif
# 	touch $@

override_dh_auto_install:
	DESTDIR=$$(pwd)/debian/tmp AM_UPDATE_INFO_DIR=no INSTALL="install --strip-program=true"   ./ns3 install
	
	mkdir -p debian/tmp/usr/bin
	# cp netanim-*/NetAnim debian/tmp/usr/bin
	# Install my own little script as a compiler
	set -e ;\
	all_libs=$$(find debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ -name 'libns3*.so' | sed -e "s|debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/||" -e 's/.so$$//' | sort) ;\
	sed -e "s/@ALL_LIBS@/$$(echo $$all_libs)/g" debian/ns3++.in > debian/tmp/usr/bin/ns3++
	chmod +x debian/tmp/usr/bin/ns3++
	# Install the upstream changelog as NEWS, as requested by the policy
	cp RELEASE_NOTES.md NEWS.md
	
override_dh_auto_test:
	-./test.py -v

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

# override_dh_link:
# 	dh_link
# 	if test -e debian/ns3-doc/usr/share/doc; then \
# 		jdupes -rl debian/ns3-doc/usr/share/doc; \
# 	fi
# 
# override_dh_install:
# 	dh_install
# 	
# ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# 	# The doc is not built when building only for a given arch (it's built in 'arch:all')
# 	if [ -e debian/ns3-doc/usr/share/doc/ns3/manual/html/_static ] ; then \
# 	  for where in manual models tutorial ; do \
# 	    for what in doctools.js language_data.js searchtools.js ; do \
# 	      rm debian/ns3-doc/usr/share/doc/ns3/$${where}/html/_static/$${what}; \
# 	      ln -s /usr/share/javascript/sphinxdoc/1.0/$${what} debian/ns3-doc/usr/share/doc/ns3/$${where}/html/_static/$${what}; \
# 	    done ; \
# 	  done ; \
# 	fi
# endif

override_dh_auto_clean:
	#-sh ./debian/clean-tree.sh
	rm -f src/core/model/version.cache
	dh_auto_clean

# ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# override_dh_compress:
# 	dh_compress -Xusr/share/doc/ns3/examples/  -Xusr/share/doc/ns3/manual/  -Xusr/share/doc/ns3/models/  -Xusr/share/doc/ns3/tutorial/
# endif

# Note to self: Download the new version by using 'uscan'

=== debian/watch ===
version=4
opts=dversionmangle=s/@DEB_EXT@// \
https://www.nsnam.org/releases/latest  ns-@ANY_VERSION@@ARCHIVE_EXT@
